var TOiR_Equipment_Window = null;
var TOiR_Equipment_WindowAdd = null;
var TOiR_Equipment_WindowEdit = null;

function show_TOiR_Equipment_Window(Xcoord,Ycoord,Wwidth,Wheight){
  Xcoord = Xcoord ? Xcoord :40;
  Ycoord = Ycoord ? Ycoord :60;  
  Wwidth = Wwidth ? Wwidth :1220;  
  Wheight = Wheight ? Wheight :400;

  Ext.define('EquipmentModel', {
    extend: 'Ext.data.Model',
    fields: ['id_equipment','maker', 'inventory_number', 'actual_number', 'serial_number', 'year_constr', 'logo', 'model','actual_model','type','date_end_warranty','planned_date_service','actual_date_last_service','master_last_service','date_last_service','client', 'count', 'date_count']
  });

  var EquipmentStore = new Ext.data.Store(
    {
        remoteSort: true,
	    autoLoad: true,
		autoDestroy: true,
	    pageSize: 50,
        model: 'EquipmentModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_Equipment.php?func=show',
          reader: 
          {
            type: 'json',
            root: 'rows',
            totalProperty: 'results'
          },
			  simpleSortMode: true
			 
		},sorters: [{
				property: 'serial_number',
				direction: 'ASC'
			}]
  });
Ext.define('СlientComboModel', {
    extend: 'Ext.data.Model',
    fields: [{name: 'client', type: 'string'},'name_TT']
});
  var СlientComboStore = new Ext.data.JsonStore(
  {     autoLoad: true,
        model: 'СlientComboModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_Client.php?func=showCombo',
          reader: 
          {
            type: 'json',
            root: 'rows',
          }
        }
   }); 

  var EquipmentPagingToolbar = new Ext.PagingToolbar({      // <---- создаем Paging
      displayInfo    : true,
      store          : EquipmentStore
  });

  EquipmentGrid = Ext.create('Ext.grid.Panel', {
    selType: 'rowmodel',
    columnLines: true,
    id: 'EquipmentGridId',
    store: EquipmentStore,
    // features: [EquipmentFilters],
    loadMask: true,
    border: false,
    autoScroll: true,
    bbar: EquipmentPagingToolbar,
    dockedItems: [{
            xtype: 'toolbar',
            items: [{
                //text: 'Добавить',
                text: all_toir.add,
                iconCls: 'add',
                handler: function(){
                  show_TOiR_Equipment_WindowAdd();
                }
            }, '-', {
                //text: 'Удалить',
                text: all_toir.del,
                iconCls: 'delete',
                handler: function(){
                  TOiR_Equipment_WindowRemove();
                }
            },'-',{
                  //text: 'Редактировать',
                  text: all_toir.edit,
                  iconCls: 'edit',
                  handler: function (){
                    var select = Ext.getCmp('EquipmentGridId').getView().getSelectionModel().getSelection()[0];
                    // alert(select.get('id_client'));
                     if (select) {
                        var id_equipment = select.get('id_equipment');
                        var client = select.get('client');
                        var maker = select.get('maker');
                        var inventory_number = select.get('inventory_number');
                        var serial_number = select.get('serial_number');
                        var year_constr = select.get('year_constr');
                        var count = select.get('count');
                        var date_count = select.get('date_count');
                        var model = select.get('model');
                        var type = select.get('type');
                        var date_end_warranty = select.get('date_end_warranty');
                        var planned_date_service = select.get('planned_date_service');
                        var actual_date_last_service = select.get('actual_date_last_service');
                        var master_last_service = select.get('master_last_service');
                        var date_last_service = select.get('date_last_service');
                        show_TOiR_Equipment_WindowEdit(id_equipment,client,maker,inventory_number,serial_number,year_constr,count,date_count,model,type,date_end_warranty,planned_date_service,actual_date_last_service,master_last_service,date_last_service);
                     
                      } else {
                        Ext.MessageBox.alert(all_toir.error, all_toir.select_row);
                      }
                    }
                }],
    }],
    listeners: 
    {
      itemdblclick: function (View,record,item,index,e,eOpts){
        var id_equipment = record.get('id_equipment');
        var client = record.get('client');
        var maker = record.get('maker');
        var inventory_number = record.get('inventory_number');
        var serial_number = record.get('serial_number');
        var year_constr = record.get('year_constr');
        var count = record.get('count');
        var date_count = record.get('date_count');
        var model = record.get('model');
        var type = record.get('type');
        var date_end_warranty = record.get('date_end_warranty');
        var planned_date_service = record.get('planned_date_service');
        var actual_date_last_service = record.get('actual_date_last_service');
        var master_last_service = record.get('master_last_service');
        var date_last_service = record.get('date_last_service');
        show_TOiR_Equipment_WindowEdit(id_equipment,client,maker,inventory_number,serial_number,year_constr,count,date_count,model,type,date_end_warranty,planned_date_service,actual_date_last_service,master_last_service,date_last_service);
      }
                   
    },
    columns:[
       {
        //text: 'Id оборудования',
        text: equip_toir.id_equipment, 
        dataIndex: 'id_equipment',
        hidden:true
      },
      {
        //text: 'Клиент',
        text: client_toir.client, 
        dataIndex: 'client',
        width: 160,
        hideable: false,
        sortable: false,
        filter: {
          type: 'string'
        }
      },
      {
        //text: 'Производитель',
        text: equip_toir.producer, 
        dataIndex: 'maker',
        width: 160,
        hideable: false,
        sortable: true,
        filter: {
          type: 'string'
        }
      },
      {
        //text: 'Инвентарный номер',
        text: equip_toir.inventory_number, 
        dataIndex: 'inventory_number',
        width: 160,
        hideable: false,
        sortable: true,
        filter: {
          type: 'string'
        }
      },
      /*{
        text: 'Фактический номер', 
        dataIndex: 'actual_number',
        width: 120,
        hideable: false,
        sortable: true,
        filter: {
          type: 'string'
        }
      },*/
      {
        //text: 'Серийный номер',
        text: equip_toir.serial_number, 
        dataIndex: 'serial_number',
        hideable: false,
        sortable: true,
        filter: {
          type: 'string'
        }
      },
      {
        //text: 'Год выпуска',
        text: equip_toir.year_of_release, 
        dataIndex: 'year_constr',
        hideable: false,
        sortable: true,
        filter: {
          type: 'numeric'
        }
      },{
        //text: 'Счетчик',
        text: equip_toir.counter,
        dataIndex: 'count',
        
          hideable: false,
          sortable: true,
          filter: {
            type: 'numeric'
          }
      }, {
        //text: 'Дата снятия',
        text: equip_toir.date_issue_is_removed, 
          dataIndex: 'date_count',
          hideable: false,
          sortable: true,
          width: 140,
          filter: {
            type: 'date'
          }
      },
      /*{
        text: 'Логотип', 
        dataIndex: 'logo',
        hideable: false,
        sortable: true,
        filter: {
          type: 'string'
        }
      },*/
      {
        //text: 'Модель',
        text: article_toir.model, 
        dataIndex: 'model',
        hideable: false,
        sortable: true,
        filter: {
          type: 'string'
        }
      }, 
      /*{
        text: 'Модель фактическая', 
        dataIndex: 'actual_model',
        hideable: false,
        sortable: true,
        width: 120,
        filter: {
          type: 'string'
        }
      },*/
      {
        //text: 'Тип',
        text: equip_toir.type, 
        dataIndex: 'type',
        hideable: false,
        sortable: true,
        filter: {
          type: 'string'
        }
      },
      {
        //text: 'Дата окончания гарантии',
        text: equip_toir.end_date_of_the_guarantee, 
        dataIndex: 'date_end_warranty',
        hideable: false,
        sortable: true,
        width: 140,
        filter: {
          type: 'date'
        }
      },
      {
        //text: 'Плановая дата ТО',
        text: equip_toir.planned_date_of_TO, 
        dataIndex: 'planned_date_service',
        hideable: false,
        sortable: true,
        width: 120,
        filter: {
          type: 'date'
        }
      },
      {
        //text: 'Фактическая дата проведения предыдущего ТО',
        text: equip_toir.the_actual_date_of_the_previousTO, 
        dataIndex: 'actual_date_last_service',
        hideable: false,
        sortable: true,
        width: 200,
        filter: {
          type: 'date'
        }
      },
      {
        //text: 'Кто проводил предыдущее ТО',
        text: equip_toir.who_spent_the_previous_TO,
        dataIndex: 'master_last_service',
        hideable: false,
        sortable: true,
        width: 200,
        filter: {
          type: 'string'
        }
      },
      {
        //text: 'Дата проведения предыдущего ремонта',
        text: equip_toir.date_of_previous_repair, 
        dataIndex: 'date_last_service',
        hideable: false,
        sortable: true,
        width: 180,
        filter: {
          type: 'date'
        }
      }
    ]
  });

  if (!TOiR_Equipment_Window) {
    TOiR_Equipment_Window = new Ext.Window({
      layout : 'fit',
      //title : 'Оборудование',
      title : TOiR.Equipment,
      closeAction : 'destroy',
      width : parseInt(Wwidth),
      height : parseInt(Wheight),
      // constrainHeader: true,
      maximizable:true,
      listeners : {
          destroy : function(){
              TOiR_Equipment_Window = null;   
          } 
      },
      items : [EquipmentGrid]
    });
  }
  function show_TOiR_Equipment_WindowAdd() {
    if(!TOiR_Equipment_WindowAdd) {
      TOiR_Equipment_WindowAdd = new Ext.Window({
        autoScroll:true,
        modal:true,
        closeAction : 'destroy',
        width: 350,
        //title : 'Добавить оборудование',
        title : equip_toir.add_equipment,
        listeners : {
            destroy : function(){
            TOiR_Equipment_WindowAdd = null;    
            }
        },
        items: [{
          xtype: 'form',
          autoScroll: true,
          bodyPadding: '5 5 5 5',
          id: "EquipmentFormId",
          bodyPadding: 5,
          border: false,
          frame: true,
          autoHeight: true,
          layout: {
              type: 'vbox',
              align: 'stretch'
          },
          // defaults: {
          //     labelAlign: 'left',
          //     labelWidth: 90,
          //     msgTarget: 'side'
          // },
          items: 
                      [
                        {
                          xtype: 'combobox',
                          //fieldLabel: 'Клиент',
                          fieldLabel: client_toir.client,
                          allowBlank: false,
                          autoSelect:true,
                          store: СlientComboStore,
                          valueField:'client',
                          displayField:'client',
                          queryMode:'remote',
                          name:'client',
                          typeAhead: true,
                          typeAheadDelay: 100
                        },
                        {
                          xtype:'textfield',
                          //fieldLabel: 'Производитель',
                          fieldLabel: equip_toir.producer,
                          name : 'maker'
                        },
                        {
                          xtype:'textfield',
                          //fieldLabel: 'Инвентарный номер',
                          fieldLabel: equip_toir.inventory_number,
                          name : 'inventory_number'
                        },
                        /*{
                          fieldLabel: 'Фактический номер', 
                          name: 'actual_number',
                          xtype:'textfield'
                        },*/
                        {
                          //fieldLabel: 'Серийный номер',
                          fieldLabel: equip_toir.serial_number, 
                          name: 'serial_number',
                          xtype:'textfield'
                        },
                        {
                          //fieldLabel: 'Год выпуска',
                          fieldLabel: equip_toir.year_of_release, 
                          name: 'year_constr',
                          xtype:'textfield'
                        },
                        {
                          //fieldLabel: 'Счетчик',
                          fieldLabel: equip_toir.counter, 
                          name: 'count',
                          xtype:'textfield',
                          allowBlank: false
                        }, {
                          //fieldLabel: 'Дата снятия показаний счетчика',
                          fieldLabel: equip_toir.date_issue_is_removed, 
                          name: 'date_count',
                          xtype:'datefield',
                          format: 'Y-m-d'
                        },
                        /*{
                          fieldLabel: 'Логотип', 
                          name: 'logo',
                          xtype:'textfield'
                        },*/
                        {
                          //fieldLabel: 'Модель',
                          fieldLabel: article_toir.model, 
                          name: 'model',
                          xtype:'textfield'
                        },
                        /*{
                          fieldLabel: 'Модель фактическая', 
                          name: 'actual_model',
                          xtype:'textfield'
                        },*/
                        {
                          //fieldLabel: 'Тип',
                          fieldLabel: equip_toir.type, 
                          name: 'type',
                          xtype:'textfield'
                        },
                        {
                          //fieldLabel: 'Дата окончания гарантии',
                          fieldLabel: equip_toir.end_date_of_the_guarantee, 
                          name: 'date_end_warranty',
                          xtype:'datefield',
                          format: 'Y-m-d'
                        },
                        {
                          //fieldLabel: 'Плановая дата ТО',
                          fieldLabel: equip_toir.planned_date_of_TO, 
                          name: 'planned_date_service',
                          xtype:'datefield',
                          format: 'Y-m-d'
                        },
                        {
                          //fieldLabel: 'Фактическая дата проведения предыдущего ТО',
                          fieldLabel: equip_toir.the_actual_date_of_the_previousTO,
                          name: 'actual_date_last_service',
                          xtype:'datefield',
                          format: 'Y-m-d'
                        },
                        {
                          //fieldLabel: 'Кто проводил предыдущее ТО',
                          fieldLabel: equip_toir.who_spent_the_previous_TO, 
                          name: 'master_last_service',
                          xtype:'textfield'
                        },
                        {
                          //fieldLabel: 'Дата проведения предыдущего ремонта',
                          fieldLabel: equip_toir.date_of_previous_repair, 
                          name: 'date_last_service',
                          xtype:'datefield',
                          format: 'Y-m-d'
                        }
                      ],
                      buttons: 
                      [
                        {  // Набор кнопок. Здесь она всего одна.
                          //text: 'Добавить',
                          text: all_toir.add,
                          handler: function()
                            {
                              var form = Ext.getCmp('EquipmentFormId').getForm();
                                  if(form.isValid())
                                  {
                                    form.submit(
                                    {
                                      //waitMsg:'Идет отправка...',
                                      waitMsg: all_toir.loading,
                                      url: 'app/TOiR_Equipment.php?func=add',
                                      //params : {key : 'val', key2 : 'val2'},
                                      success: function(form,response) 
                                      {
                                        // Ext.Msg.alert('Внимание','Успешно добавлено'); 
                                        TOiR_Equipment_WindowAdd.destroy();
                                        Ext.getCmp('EquipmentGridId').store.load();
                                        Ext.getCmp('EquipmentGridId').getView().refresh(); 
                                      },
                                      failure : function()
                                      {
                                        Ext.Msg.alert(all_toir.attention, all_toir.error); 
                                      }
                                    });
                                  }else
                                    {
                                      Ext.Msg.alert(all_toir.attention, all_toir.required_fields); 
                                    }
                            }
                         },
                         {
                            //text: 'Отмена',
                            text: all_toir.cancel,
                            handler: function()
                                      {
                                        TOiR_Equipment_WindowAdd.close();
                                      }
                    }] 
        }]
      });
    }
    TOiR_Equipment_WindowAdd.show();
  }
  function TOiR_Equipment_WindowRemove() {
    if (EquipmentGrid) {
      var sm = EquipmentGrid.getSelectionModel();
      var rs = sm.getSelection();
      if(!rs) return false;
      var id_equipment = rs[0].get('id_equipment');
      if (!rs.length) {
          Ext.Msg.alert(all_toir.attention, equip_toir.the_equipment_is_not_selected);
          return;
          }
      Ext.Msg.confirm(all_toir.attention, equip_toir.are_you_sure_you_want_to_delete_the_selected_equipment, function (button) {
          if (button == 'yes') {
                      Ext.Ajax.request({  
                          url : 'app/TOiR_Equipment.php?func=del',
                          method: 'GET',
                          params: {id_equipment: id_equipment}, 
                          success: function(objServerResponse){  
                               }
                          });
                       EquipmentGrid.store.remove(rs[0]);
                                }
          });
                              
  }
}
  function show_TOiR_Equipment_WindowEdit(id_equipment,client,maker,inventory_number,serial_number,year_constr,count,date_count,model,type,date_end_warranty,planned_date_service,actual_date_last_service,master_last_service,date_last_service) {
    if (!TOiR_Equipment_WindowEdit){
      TOiR_Equipment_WindowEdit = new Ext.Window({
        autoScroll:true,
        // bodyPadding: 5,
        width: 350,
        modal:true,
        //title : 'Редактировать оборудование',
        title : equip_toir.edit_equipment,
        // id: 'ClientFormId',
        listeners : {
              destroy : function(){
              TOiR_Equipment_WindowEdit = null;    
              }
          },

        items: [{
          xtype: 'form',
          autoScroll: true,
          bodyPadding: '5 5 5 5',
          id: "EquipmentFormId",
          border: false,
          frame: true,
          autoHeight: true,
          layout: {
            type: 'vbox',
            align: 'stretch'
          },
          // defaults: {
          //   labelAlign: 'left',
          //   labelWidth: 90,
          //   msgTarget: 'side'
          // },
          items: [
            {
                              xtype:'hiddenfield',
                              name : 'id_equipment',
                              value: id_equipment
                            },
                            {
                              xtype: 'combobox',
                              //fieldLabel: 'Клиент',
                              fieldLabel: client_toir.client,
                              autoSelect:true,
                              store: СlientComboStore,
                              valueField:'client',
                              displayField:'client',
                              queryMode:'remote',
                              name:'client',
                              typeAhead: true,
                              typeAheadDelay: 100,
                              value: client
                            },
                            {
                              xtype:'textfield',
                              //fieldLabel: 'Производитель',
                              fieldLabel: equip_toir.producer,
                              name : 'maker',
                              value: maker
                            },
                            {
                              xtype:'textfield',
                              //fieldLabel: 'Инвентарный номер',
                              fieldLabel: equip_toir.inventory_number,
                              name : 'inventory_number',
                              value: inventory_number
                            },
                            /*{
                              fieldLabel: 'Фактический номер', 
                              name: 'actual_number',
                              xtype:'textfield'
                            },*/
                            {
                              //fieldLabel: 'Серийный номер',
                              fieldLabel: equip_toir.serial_number, 
                              name: 'serial_number',
                              xtype:'textfield',
                              value: serial_number
                            },
                            {
                              //fieldLabel: 'Год выпуска',
                              fieldLabel: equip_toir.year_of_release, 
                              name: 'year_constr',
                              xtype:'textfield',
                              value: year_constr
                            },
                            {
                              //fieldLabel: 'Счетчик',
                              fieldLabel: equip_toir.counter, 
                              name: 'count',
                              allowBlank: false,
                              xtype:'textfield',
                              value: count
                            }, {
                              //fieldLabel: 'Дата снятия показаний счетчика',
                              fieldLabel: equip_toir.date_issue_is_removed,
                              name: 'date_count',
                              xtype:'datefield',
                              format: 'Y-m-d',
                              value: date_count
                            },
                            /*{
                              fieldLabel: 'Логотип', 
                              name: 'logo',
                              xtype:'textfield'
                            },*/
                            {
                              //fieldLabel: 'Модель',
                              fieldLabel: article_toir.model, 
                              name: 'model',
                              xtype:'textfield',
                              value: model
                            },
                            // {
                            //   fieldLabel: 'Модель фактическая', 
                            //   name: 'actual_model',
                            //   xtype:'textfield'
                            // },
                            {
                              //fieldLabel: 'Тип',
                              fieldLabel: equip_toir.type, 
                              name: 'type',
                              xtype:'textfield',
                              value: type
                            },
                            {
                              //fieldLabel: 'Дата окончания гарантии',
                              fieldLabel: equip_toir.end_date_of_the_guarantee, 
                              name: 'date_end_warranty',
                              xtype:'datefield',
                              format: 'Y-m-d',
                              value: date_end_warranty
                              
                            },
                            {
                              //fieldLabel: 'Плановая дата ТО',
                              fieldLabel: equip_toir.planned_date_of_TO,
                              name: 'planned_date_service',
                              xtype:'datefield',
                              format: 'Y-m-d',
                              value: planned_date_service
                            },
                            {
                              //fieldLabel: 'Фактическая дата проведения предыдущего ТО',
                              fieldLabel: equip_toir.the_actual_date_of_the_previousTO, 
                              name: 'actual_date_last_service',
                              xtype:'datefield',
                              format: 'Y-m-d',
                              value: actual_date_last_service
                            },
                            {
                              //fieldLabel: 'Кто проводил предыдущее ТО',
                              fieldLabel: equip_toir.who_spent_the_previous_TO, 
                              name: 'master_last_service',
                              xtype:'textfield',
                              value: master_last_service
                            },
                            {
                              //fieldLabel: 'Дата проведения предыдущего ремонта',
                              fieldLabel: equip_toir.date_of_previous_repair, 
                              name: 'date_last_service',
                              xtype:'datefield',
                              format: 'Y-m-d',
                              value: date_last_service
                            }
                          ],
                          buttons: [
                          {  // Набор кнопок. Здесь она всего одна.
                              //text: 'Сохранить',
                              text: all_toir.save,
                              handler: function()
                                {
                                  var form = Ext.getCmp('EquipmentFormId').getForm();
                                  if(form.isValid())
                                  {
                                    
                                    form.submit(
                                    {
                                      //waitMsg:'Идет отправка...',
                                      waitMsg: all_toir.loading,
                                      url: 'app/TOiR_Equipment.php?func=update',
                                      //params : {key : 'val', key2 : 'val2'},
                                      success: function(form,response) 
                                      {
                                        // Ext.Msg.alert('Внимание','Успешно изменено'); 
                                        TOiR_Equipment_WindowEdit.destroy();
                                        Ext.getCmp('EquipmentGridId').store.load();
                                        Ext.getCmp('EquipmentGridId').getView().refresh(); 
                                      },
                                      failure : function()
                                      {
                                        Ext.Msg.alert(all_toir.attention, all_toir.error); 
                                      }
                                    });
                                  }else
                                    {
                                      Ext.Msg.alert(all_toir.attention, all_toir.required_fields); 
                                    }
                                }
                          },
                          {
                            //text: 'Отмена',
                            text: all_toir.cancel,
                            handler: function()
                                      {
                                        TOiR_Equipment_WindowEdit.close();
                                      }
                          }
          ]
        }]
      });
    }
    TOiR_Equipment_WindowEdit.show();
  }

TOiR_Equipment_Window.show();
}