var TOiR_ResultJob_Window = null;
var TOiR_ResultJob_WindowAdd = null;
var TOiR_ResultJob_WindowEdit = null;

   Ext.define('ResultJobModel', {
    extend: 'Ext.data.Model',
    fields: ['id_result_job', 'name_result_job']
  });

  var ResultJobStore = new Ext.data.Store({
        autoLoad: true,
        // autoDestroy: true,
        model: 'ResultJobModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_ResultJob.php?func=show',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
    });
  
function show_TOiR_ResultJob_Window(Xcoord,Ycoord,Wwidth,Wheight){

	Xcoord = Xcoord ? Xcoord :40;
    Ycoord = Ycoord ? Ycoord :60;  
    Wwidth = Wwidth ? Wwidth :700;  
    Wheight = Wheight ? Wheight :400;

 

	ResultJobGrid = Ext.create('Ext.grid.Panel', {
		selType: 'rowmodel',
		columnLines: true,
		id: 'TOiR_ResultJobGridId',
		store: ResultJobStore,
		loadMask: true,
	    border: false,
	    autoScroll: true,
	    dockedItems: [{
	        xtype: 'toolbar',
	        items: [{
	            //text: 'Добавить',
				text: all_toir.add,
	            iconCls: 'add',
	            handler: function(){
	                show_TOiR_ResultJob_WindowAdd();
	              }
	            },
	            , '-', {
	            //text: 'Удалить',
				text: all_toir.del,
	            iconCls: 'delete',
	            handler: function() {
	                show_TOiR_ResultJob_WindowRemove();
	              }
	            }
	        ],
	    }],
	    columns: [
	    	{
	        //text: 'Id Результата работы', 
			text: job_toir.id_results_of_the_work, 
	        dataIndex: 'id_result_job',
	        hideable: false,
	        sortable: true,
	        hidden:true
	      },
	      {
	        //text: 'Результаты работы', 
			text: job_toir.results_of_the_work, 
	        dataIndex: 'name_result_job',
	        flex:1,
	        hideable: false,
	        sortable: true
	      }
	    ],
	    listeners: {
	    	itemdblclick: function (View,record,item,index,e,eOpts) {
          var name = record.get('name_result_job');
          var id = record.get('id_result_job');
	    		show_TOiR_EvaluationCriteria_WindowEdit(name,id);
	    	}
	    }
	});

    if (!TOiR_ResultJob_Window) {
    	TOiR_ResultJob_Window = new Ext.Window({
    		layout : 'fit',
            //title : 'Результаты работ',
			title : job_toir.results_of_the_work,
            closeAction : 'destroy',
            width : parseInt(Wwidth),
            height : parseInt(Wheight),
            //minimizable: true,
            // constrainHeader: true,
            maximizable:true,
            // x: parseInt(Xcoord),
            // y: parseInt(Ycoord),
            listeners : {
                destroy : function(){
                    TOiR_ResultJob_Window = null;   
                }
            },
            items : [ResultJobGrid]
    	});
    }

    function show_TOiR_ResultJob_WindowAdd() {
    	if (!TOiR_ResultJob_WindowAdd) {
            TOiR_ResultJob_WindowAdd = new Ext.Window({
                width: 300,
                modal:true,
                height: 150,
                //title: 'Новый результат работы',
				title: job_toir.new_result_of_the_work,
                closeAction: 'destroy',
                layout: 'fit',
                resizable: true,
                listeners : {
                    destroy : function(){
                    TOiR_ResultJob_WindowAdd = null;    
                    }
                },
                items: [{
                    xtype: 'form',
                    autoScroll: true,
                    bodyPadding: '5 5 5 5',
                    id: "TOiR_ResultJobFormId",
                    border: false,
                    frame: true,
                    autoHeight: true,
                    layout: {
                        type: 'vbox',
                        align: 'stretch'
                    },
                    // defaults: {
                    //     labelAlign: 'left',
                    //     labelWidth: 90,
                    //     msgTarget: 'side'
                    // },
                    items: [
                	{
           			    xtype:'textfield',
                        //fieldLabel: 'Результат работы',
						fieldLabel: job_toir.results_of_the_work,
                        name : 'name_result_job',
                        allowBlank: false
                	}],
                	buttons: [
                    	{
                      	//text: 'Добавить',
						text: all_toir.add,
                      	handler: function()
                        	{
                          	var form = this.up('form').getForm();
                              if(form.isValid())
                              {
                                form.submit(
                                {
                                  //waitMsg:'Идет отправка...',
								  waitMsg: all_toir.loading,
                                  url: 'app/TOiR_ResultJob.php?func=add',
                                  params : {key : 'val', key2 : 'val2'},
                                  success: function(form,response) 
                                  {
                                    // Ext.Msg.alert('Внимание','Оценочный критерий успешно добавлен'); 
                                    TOiR_ResultJob_WindowAdd.destroy();
                                    Ext.getCmp('TOiR_ResultJobGridId').store.load();
                                    Ext.getCmp('TOiR_ResultJobGridId').getView().refresh();
                                  },
                                  failure : function()
                                  {
                                    Ext.Msg.alert(all_toir.attention, all_toir.error); 
                                  }
                                });
                              }else
                                {
                                  Ext.Msg.alert(all_toir.attention, all_toir.required_fields); 
                                }
                        }
                    },
                    {
                        //text: 'Отмена',
						text: all_toir.cancel,
                        handler: function()
                                  {
                                   TOiR_ResultJob_WindowAdd.destroy();
                                  }
                      }
                    ] 
                }]
                 
            });
            
        }
        TOiR_ResultJob_WindowAdd.show();
    }
    function show_TOiR_ResultJob_WindowRemove() {
    	if (ResultJobGrid) {
	      var sm = ResultJobGrid.getSelectionModel();
	      var rs = sm.getSelection();
	      if(!rs) return false;
	      var id_result_job = rs[0].get('id_result_job');
	      if (!rs.length) {
	          Ext.Msg.alert(all_toir.attention, all_toir.select_row);
	          return;
	          }
	            Ext.Msg.confirm(ll_toir.attention, job_toir.are_you_sure_you_want_to_delete_the_selected_result_of_the_work, function (button) {
	              if (button == 'yes') {
	                          Ext.Ajax.request({  
	                              url : 'app/TOiR_ResultJob.php?func=del',
	                              method: 'GET',
	                              params: {id_result_job: id_result_job}, 
	                              success: function(objServerResponse){  
	                                   }
	                              });
	                           ResultJobGrid.store.remove(rs[0]);
	                                    }
	              });
	            } 
    }
    function show_TOiR_EvaluationCriteria_WindowEdit(name,id) {
    	if (!TOiR_ResultJob_WindowEdit) {
			TOiR_ResultJob_WindowEdit = new Ext.Window({
				        width:500,
                height:200,
                //title: 'Редактировать',
				title: all_toir.edit,
                closeAction : 'destroy',
                layout:'fit',
                resizable: true,
				        constrainHeader: true,
                modal:true,
				listeners : {
				destroy : function(){
					TOiR_ResultJob_WindowEdit = null;	
					}
				},
                items:[
				{
					xtype: 'form',
					autoScroll: true,
					bodyPadding: '5 5 5 5',
					id: "TOiR_ResultJobFormId",
					border: false,
					frame: true,
					autoHeight: true,
					//fieldwidth:'width:150px',
					//layout: 'anchor',
					layout: {
						type: 'vbox',
						align: 'stretch'
					},
					// defaults: {
					// 	//fileUpload: true,
					// 	labelAlign: 'left',
					// 	labelWidth: 90,
					// 	//fieldWidth: '90%',
					// 	msgTarget: 'side'
					// },
					items: [
					{
                              xtype:'hiddenfield',
                              name : 'id_result_job',
                              value: id
                            },
                            {
                              xtype:'textfield',
                              //fieldLabel: 'Результат работы',
							  fieldLabel: job_toir.results_of_the_work,
                              name : 'name_result_job',
                              value: name
                            }
					],
                    buttons: [{  
                        //text: 'Сохранить',
						text: all_toir.save,
                        handler: function() {
                            var form = Ext.getCmp('TOiR_ResultJobFormId').getForm();
                            if(form.isValid()) {
                            	form.submit({
                              		//waitMsg:'Идет отправка...',
									waitMsg: all_toir.loading,
                              		url: 'app/TOiR_ResultJob.php?func=update',
                              		params : {key : 'val', key2 : 'val2'},
                              		success: function(form,response) {
                                        // Ext.Msg.alert('Внимание','Оценочный критерий успешно изменен'); 
                                        TOiR_ResultJob_WindowEdit.destroy();
                                        Ext.getCmp('TOiR_ResultJobGridId').store.load();
                                        Ext.getCmp('TOiR_ResultJobGridId').getView().refresh();
                             		},
                                    failure : function() {
                                        Ext.Msg.alert(all_toir.attention, all_toir.error); 
                                    }
                            	});
                          	} else {
                              Ext.Msg.alert(all_toir.attention, all_toir.required_fields); 
                            }
                        }
                    },
                    {
                    	//text: 'Отмена',
						text: all_toir.cancel,
                    	handler: function() {
                            TOiR_ResultJob_WindowEdit.destroy();
                        }
                  	}] 
                }]
			});
		}
        TOiR_ResultJob_WindowEdit.show();     
	}

  TOiR_ResultJob_Window.show();
  Ext.getBody().unmask(all.loading);
    }
