var TOiR_messages_Window = null;
var TOiR_messages_WindowAddEdit = null;

function show_TOiR_messages_Window(Xcoord,Ycoord,Wwidth,Wheight) {

    Xcoord = Xcoord ? Xcoord :40;
    Ycoord = Ycoord ? Ycoord :60;  
    Wwidth = Wwidth ? Wwidth :600;  
    Wheight = Wheight ? Wheight :400;

    Ext.define('messagesModel', {
        extend: 'Ext.data.Model',
        fields: ['id_message', 'whom_message', 'from_message', 'topic', 'message', 'status', 'time_message']
    });

    messagesStore = new Ext.data.Store({
        autoLoad: true,
        model: 'messagesModel',
        proxy: {
            type: 'ajax',
            url: 'app/TOiR_messages.php?func=show',
            reader: {
                type: 'json',
                root: 'rows',
                totalProperty: 'total'
            }
        }
    });

    var messageGridPaging = new Ext.PagingToolbar ({
        displayInfo    : true,
        store          : messagesStore
    });

    var messagesGrid = Ext.create('Ext.grid.Panel', {
        selType: 'rowmodel',
        columnLines: true,
        id: 'messagesGridId',
        store: messagesStore,
        loadMask: true,
        border: false,
        autoScroll: true,
        bbar: [messageGridPaging],
        dockedItems: [{
            xtype: 'toolbar',
            items: [
                {
                    //text: 'Новое сообщение',
                    text: mess_toir.new_message,
                    iconCls: 'add',
                    handler: function () {
                        // alert(1);
                        show_TOiR_message_WindowAddEdit();
                    }
                },
                '-',
                {
                    //text: 'Удалить сообщение',
                    text: mess_toir.delete_the_message,
                    iconCls: 'delete',
                    handler: function() {
                        TOiR_message_WindowRemove();
                    }
                },'-',{
                  //text: 'Редактировать',
                  text: all_toir.edit,
                  iconCls: 'edit',
                  handler: function (){
                    var select = Ext.getCmp('messagesGridId').getView().getSelectionModel().getSelection()[0];
                    // alert(select.get('id_client'));
                     if (select) {
                        var id = select.get('id_message');
                        var from_message = select.get('from_message');
                        var whom_message = select.get('whom_message');
                        var topic = select.get('topic');
                        var message = select.get('message');

                        show_TOiR_message_WindowAddEdit(id,from_message,whom_message,topic,message);
                      } else {
                        Ext.MessageBox.alert(all_toir.error, all_toir.select_row);
                      }
                    }
                }
            ]
        }],
        columns: [
        {
            //text: 'ID сообщения',
            text: mess_toir.message_ID,
            dataIndex: 'id_message',
            hidden: true
        },
        {
            //text: 'Дата/Время',
            text: mess_toir.date_time,
            dataIndex: 'time_message',
            sortable: true,
            width: 120
        },
        {
            //text: 'Имя отправителя',
            text: mess_toir.sender_name,
            dataIndex: 'from_message',
            sortable: true        ,
            flex:1
        },
        {
            //text: 'Имя получателя',
            text: mess_toir.recipient_name,
            dataIndex: 'whom_message',
            sortable: true ,
            hidden: true
        },
        {
            //text: 'Тема сообщения',
            text: mess_toir.message_subject,
            dataIndex: 'topic',
            sortable: true,
            flex:2
        },
        {
            //text: 'Сообщение',
            text: mess_toir.message,
            dataIndex: 'message',
            sortable: true,
            flex:3
        }
        ],
        listeners: {
            itemdblclick: function(View,record,item,index,e,eOpts) {
                var id = record.get('id_message');
                var from_message = record.get('from_message');
                var whom_message = record.get('whom_message');
                var topic = record.get('topic');
                var message = record.get('message');

                show_TOiR_message_WindowAddEdit(id,from_message,whom_message,topic,message);

            }
        }
    });

    if (!TOiR_messages_Window) {
        TOiR_messages_Window = new Ext.Window({
            autoScroll:true,
            layout : 'fit',
            closeAction : 'destroy',
            width : parseInt(Wwidth),
            height : parseInt(Wheight),
            //title : 'Сообщения',
            title : TOiR.messages,
            maximizable:true,
            listeners : {
                destroy : function(){
                    TOiR_messages_Window = null;    
                }
            },
            items: [messagesGrid]
        });
    }

    function show_TOiR_message_WindowAddEdit(id,from_message,whom_message,topic,message) {
        if (typeof id == 'undefined') {
            //title = 'Новое сообщение';
            title = mess_toir.new_message;
            //titleBtn = 'Отправить';
            titleBtn = mess_toir.send;
            func = 'add';
            id = '';
            from_message = '';
            whom_message = '';
            topic = '';
            message = '';
        } else {
            //title = 'Редактировать сообщение';
            title = mess_toir.edit_message;
            //titleBtn = 'Изменить';
            titleBtn = all_toir.edit;
            func = 'edit';
        }

        if (!TOiR_messages_WindowAddEdit) {
            TOiR_messages_WindowAddEdit = new Ext.Window({
                autoScroll:true,
                layout : 'fit',
                closeAction : 'destroy',
                width : 400,
                height : 300,
                modal:true,
                title : title,
                maximizable:true,
                listeners : {
                    destroy : function(){
                        TOiR_messages_WindowAddEdit = null;
                    }
                },
                items: [{
                    xtype: 'form',
                    autoScroll: true,
                    bodyPadding: '5 5 5 5',
                    id: "messagesAddEditFormId",
                    bodyPadding: 5,
                    border: false,
                    frame: true,
                    autoHeight: true,
                    layout: {
                          type: 'vbox',
                          align: 'stretch'
                      },
                      
                    items: [
                    {
                        xtype: 'hidden',
                        fieldLabel: 'ID',
                        dataIndex: 'id_message',
                        id:'id_message',
                        value: id
                    },
                    {
                        xtype: 'textfield',
                        //fieldLabel: 'Отправитель',
                        fieldLabel: mess_toir.sender,
                        dataIndex: 'from_message',
                        id:'from_message',
                        value: from_message
                    },
                    {
                        xtype: 'textfield',
                        //fieldLabel: 'Получатель',
                        fieldLabel: mess_toir.recipient,
                        dataIndex: 'whom_message',
                        id:'whom_message',
                        value: whom_message
                    },
                    {
                        xtype: 'textfield',
                        //fieldLabel: 'Тема сообщения',
                        fieldLabel: mess_toir.message_subject,
                        dataIndex: 'topic',
                        id:'topic',
                        value: topic
                    },
                    {
                        xtype: 'textarea',
                        //fieldLabel: 'Сообщение',
                        fieldLabel: mess_toir.message,
                        dataIndex: 'message',
                        id:'message',
                        value: message
                    }
                    ],
                    buttons: [
                        {
                            text: titleBtn,
                            handler: function () {
                                var id_message = Ext.getCmp('id_message').getValue();
                                var from_message = Ext.getCmp('from_message').getValue();
                                var whom_message = Ext.getCmp('whom_message').getValue();
                                var topic = Ext.getCmp('topic').getValue();
                                var message = Ext.getCmp('message').getValue();
                                $.post('app/TOiR_messages.php?func='+func,
                                    {id_message:id_message,from_message:from_message,whom_message:whom_message,topic:topic,message:message},
                                    function (data) {
                                    // Ext.Msg.alert('Внимание','Сообщение успешно отправлено'); 
                                    TOiR_messages_WindowAddEdit.destroy();
                                    Ext.getCmp('messagesGridId').store.load();
                                    Ext.getCmp('messagesGridId').getView().refresh(); 
                                });
                            }
                        },
                        {
                            //text: "Отмена",
                            text: all_toir.cancel,
                            handler: function () {
                                TOiR_messages_WindowAddEdit.close();
                            }
                        }
                    
                    ]
            }]
                
                
            });
        }
        TOiR_messages_WindowAddEdit.show();
    }
    function TOiR_message_WindowRemove() {
        if (messagesGrid) {
              var sm = messagesGrid.getSelectionModel();
              var rs = sm.getSelection();
              if(!rs) return false;
              var id_message = rs[0].get('id_message');
              if (!rs.length) {
                  Ext.Msg.alert(all_toir.attention, mess_toir.message_is_not_selected);
                  return;
                  }
              Ext.Msg.confirm(all_toir.attention, mess_toir.are_you_sure_you_want_to_delete_this_message, function (button) {
                  if (button == 'yes') {
                              Ext.Ajax.request({  
                                  url : 'app/TOiR_messages.php?func=del',
                                  method: 'GET',
                                  params: {id_message: id_message}, 
                                  success: function(objServerResponse){  
                                       }
                                  });
                               messagesGrid.store.remove(rs[0]);
                                        }
                  });
                                      
          }
    }


TOiR_messages_Window.show();
} 