var TOiR_routes_Window = null;
var PanelMapRoutes = null;
var globalUserIDRout;


var directionsService = new google.maps.DirectionsService();

Ext.define('TOiR_UsersRoutesModel', {
    extend: 'Ext.data.Model',
    fields: ['id' , 'name', {name: 'track', type: 'bool', defaultValue:'false'}]
});

var TOiR_UsersRoutesStore = new Ext.data.Store(
  {     
		autoLoad: true,
		//autoDestroy: true,
        model: 'TOiR_UsersRoutesModel',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_routes.php?func=showUsers',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

Ext.define('TOiR_pointsVisitStoreModel', {
    extend: 'Ext.data.Model',
    fields: ['id', 'status', 'client', 'outlet', 'address', 'time_execute', 'job_type', 'id_outlet', 'geoX', 'geoY', 'time_beginning_work']
});

var pointsVisitStore = new Ext.data.Store({     
	//autoLoad: true,				
    model: 'TOiR_pointsVisitStoreModel',
       proxy: {
          type: 'ajax',
          url: 'app/TOiR_routes.php?func=show',
          reader: {
            type: 'json',
            root: 'rows'
          }
	   }
});

///________________________
Ext.define('TOiR_TripPlanningModelRoutes', {
    extend: 'Ext.data.Model',
    fields: ['id','closed',	'name',	'distance',	'time',	'comments',	'startTime', 'endTime', 'dispatcher_ID','name_master', 
             'calculate', 'masterID', {name: 'bildRoutePlan', type: 'bool'}, {name: 'bildRouteRealPath', type: 'bool'}, 
             {name: 'monit_car', type: 'bool', defaultValue: 'false'}, 'imei', 'Signal']
});


var TOiR_TripPlanningStoreRoutes = new  Ext.data.Store(
  {     
		//autoLoad: true,	
        model: 'TOiR_TripPlanningModelRoutes',
        proxy: 
        {
          type: 'ajax',
          url: 'app/TOiR_planning.php?func=showTrip',
          reader: 
          {
            type: 'json',
            root: 'rows'
          }
        }
});

Ext.define('TOiR_pointsVisitStoreModelRoutes', {
    extend: 'Ext.data.Model',
    fields: ['id', 'status', 'client', 'outlet', 'address', 'time_execute', 'job_type', 'id_outlet', 'geoX', 'geoY', 'time_beginning_work']
});

var pointsVisitStoreRoutes = new Ext.data.Store({     
	//autoLoad: true,				
    model: 'TOiR_pointsVisitStoreModelRoutes',
       proxy: {
          type: 'ajax',
          url: 'app/TOiR_routes.php?func=show',
          reader: {
            type: 'json',
            root: 'rows'
          }
	   }
});

function show_TOiR_routes_Window(Xcoord,Ycoord,Wwidth,Wheight){
	var intervalID = null;
	pointsVisitStoreRoutes.removeAll();
	Xcoord = Xcoord ? Xcoord :40;
    Ycoord = Ycoord ? Ycoord :60;  
    Wwidth = Wwidth ? Wwidth :1100;  
    Wheight = Wheight ? Wheight :600;
    
    PanelMapRoutes = Ext.create('Ext.ux.GMapPanel', {
        //title: 'Положение на карте',
        zoomLevel:11,
    	
        gmapType: 'map',
        padding: 170,
    	id: 'routes_map_panel',	
        //width: 325,
        //height: '50%', 
        mapConfOpts: ['enableScrollWheelZoom','enableDoubleClickZoom','enableDragging'],
        setCenter: {
            lat:'50.5',
            lng:'30.5'
        }
    });
    
    var PBRoutesGrig = new Ext.create('Ext.grid.Panel',{
        //title: 'Маршруты',
		title: plan_toir.routes,
    	selType: 'rowmodel',
        columnLines: true,
        id: 'TOiR_RoutesGridId',
        layout: 'fit',
        //store: TOiR_UsersRoutesStore,
        store: TOiR_TripPlanningStoreRoutes,
        loadMask: true,
        border: false,
        autoScroll: true,
        //bodyPadding: 1, 
        columns:[/*{
        	xtype: 'rownumberer',
			width: 30,	
        }, {        	
        	text: 'Рабочая бригада', 
            dataIndex: 'name',
            sortable: true,
            flex: 1
        }, {
        	xtype: 'checkcolumn',
        	text: 'Трек',
        	dataIndex: 'track',
            sortable: false
        }*/{
        	//xtype: 'rownumberer',
        	text: 'ID',
        	dataIndex: 'id',
			width: 30,	
        }, {
        	//text: 'Статус',
			text: plan_toir.status,
        	dataIndex: 'calculate',
        	style: 'text-align:center',            
            align: 'center',
        	sortable: false,
        }, {        	
        	//text: 'Название', 
			text: outlet_toir.title, 
            dataIndex: 'name',
            sortable: true,
            //flex: 1
        }, {
        	//text: 'Бригада', 
			text: plan_toir.team, 
            dataIndex: 'name_master',
            sortable: true,
            flex: 1
        }, {
        	
        	xtype: 'checkcolumn',
        	//text: 'Маршрут',
			text: routes_toir.route,
        	dataIndex: 'bildRoutePlan',
            sortable: false,
            listeners:
            {
                checkchange:function(CheckColumn, rowIndex, checked, eOpts )
                {
                	//RecordCarPanel=Car_panel_Grid.store.getAt(rowIndex);
                	var record = TOiR_TripPlanningStoreRoutes.getAt(rowIndex);
                	console.log(record);
                	console.log(rowIndex);
                	console.log(checked);
                	
                	if (record.get('distance')) {
                    	
                        if (checked==true)
                        {                  	
                            
                        	tracingRoute(record.get('id'));
                        }
                        else  
                        {
                            offTracingPoute(record.get('id'));
                        }    
                    } else {
                    	Ext.Msg.alert(all.attention, routes_toir.you_can_not_build_uncount_route);
                    	record.set('bildRoutePlan', false);
                    }
                	
                }
            }
        },{
            //text : 'Состояние соединения',
            //id:'cooord_come_monit',
            //text : '<img src="images/conection-type.png" style="margin: 0 0 0 0">',
//            text : '<img src="images/conection-type.png" >',
            //text: 'Соединение',
			text: routes_toir.connection,
            //titleAlign: 'right',
            //tooltip: 'Состояние соединения',
            style: 'text-align:center',            
            align: 'center',
            textAlign: 'right', 
            tooltip: cars.connection_status,
            dataIndex: 'Signal',
            width: 80,
            sortable: false,
            hideable: false,
            /*sortable: true,
            hideable: true,*/
			groupable: false/*,
            editor: 'textfield'*/
           
        },/*, {
        	xtype: 'checkcolumn',
        	text: 'Путь',
        	dataIndex: 'bildRouteRealPath',
            sortable: false,
            listeners: {
            	checkchange:function(CheckColumn, rowIndex, checked, eOpts )
                {
                	//RecordCarPanel=Car_panel_Grid.store.getAt(rowIndex);
                	var record = TOiR_TripPlanningStore.getAt(rowIndex);
                	console.log(record);
                	console.log(rowIndex);
                	console.log(checked);
                	
                	if (record.get('distance')) {
                    	
                        if (checked==true)
                        {                  	
                            
                        	tracing('');
                        }
                        else  
                        {
                        	 off_tracing('');
                        }    
                    } else {
                    	Ext.Msg.alert(all.attention, 'Нельзя построить непросчитанный маршрут');
                    	record.set('bildRoutePlan', false);
                    }
                	
                }
            }
        }*/{
        	xtype: 'checkcolumn',
        	//text: 'Мониторинг',
			text: routes_toir.monitoring,
        	dataIndex: 'monit_car',
            sortable: false,
            listeners: {
            	checkchange:function(CheckColumn, rowIndex, checked, eOpts )
                {
            		var record = TOiR_TripPlanningStoreRoutes.getAt(rowIndex);
            		var imei = record.get('imei');
            		
            		if (checked==true)
                    {						
						
                    }
                    else  
                    {
                        
                    	var map_googl=Ext.getCmp('routes_map_panel');
                    	var imei_point = "point_" + imei;
                    	map_googl.deleteMarker(imei_point);					
						
                    }
                }
            }
        }],
        listeners: {
        	itemclick: function(cmp, records) {
        		console.log(records);
        		var time = Ext.getCmp('monitoring_date_id').getRawValue();
        		globalUserIDRout = records.get('masterID');
        		
        		if (intervalID) {
        			clearInterval(intervalID);
        			intervalID = null;
        		}
        		if (!intervalID) {
        			intervalID = setInterval(function() {
        				reloadGridByTime(globalUserIDRout, time)
        			}, 20000);
        		}        		
        		
        		pointsVisitStoreRoutes.load({
        			params: {
        				userID: globalUserIDRout,
        				time: time
        			}
        		});
        	}
        }
    });
    
    var westPanel = new Ext.panel.Panel({
    	//title: 'Точки посещения',
    	//layout: 'fit',
    	//height: 100,
    	defaults: {
			//fileUpload: true,
			//labelAlign: 'left',
			labelWidth: 120,
			msgTarget: 'side',
			
			//width: 350,
		},
    	items: [{
    		xtype: 'datefield',
			//fieldLabel: 'Дата мониторинга',
			fieldLabel: routes_toir.date_monitoring,
			format: 'Y-m-d',
			altFormats: 'Y-m-d',
			id: 'monitoring_date_id',
			startDay: 1,
			margin: '5 5 5 5',
			name : 'date_create',
			value: new Date(),
			listeners: {
				select: function() {
					if (intervalID) {
	        			clearInterval(intervalID);
	        			intervalID = null;
	        		}
					pointsVisitStoreRoutes.removeAll();
					clearMapMonitoring();
					var time = Ext.getCmp('monitoring_date_id').getRawValue();		
					TOiR_TripPlanningStoreRoutes.load({
						params: {
							time: time
						}
					});
				}
			}
    		
    	}, PBRoutesGrig]
    });
    
    var southPanel = new Ext.create('Ext.grid.Panel',{
        //title: 'Точки посещения',
		title: plan_toir.points_visit,
    	selType: 'rowmodel',
        columnLines: true,
        //id: 'TOiR_RoutesGridId',
        store: pointsVisitStoreRoutes,
        loadMask: true,
        border: false,
        autoScroll: true,
        columns:[{
        	//xtype: 'rownumberer',
        	text: 'ID',
        	dataIndex: 'id',
			width: 30,	
        }, {
        	//text: 'Статус', 
			text: plan_toir.status, 
            dataIndex: 'status',
            style: 'text-align:center',            
            align: 'center',
            sortable: true,
        }, {
        	//text: 'Клиент', 
			text: client_toir.client, 
            dataIndex: 'client',
            sortable: true,
        }, {
        	//text: 'Тип работ', 
			text: plan_toir.type_of_works,
            dataIndex: 'job_type',
            sortable: true,
        }, {
        	//text: 'Торговая точка', 
			text: plan_toir.outlet,
            dataIndex: 'outlet',
            sortable: true,
        }, {
        	//text: 'Адрес', 
			text: client_toir.address, 
            dataIndex: 'address',
            sortable: true,
            flex: 1
        }, {
        	//text: 'Время приезда', 
			text: plan_toir.time_of_arrival, 
            dataIndex: 'time_execute',
            sortable: true,
        }],
        listeners: {
        	itemdblclick: function (cmp, record) {
        		console.log(record);
        		var select = Ext.getCmp('TOiR_RoutesGridId').getView().getSelectionModel().getSelection()[0];
        		if (select.get('distance')) {        			
        			GoogleLatLng = new google.maps.LatLng(record.get('geoY'), record.get('geoX'));
        			PanelMapRoutes.addMarker(GoogleLatLng,{cursor:'pointOnMap', icon:'images/record.png'},false,false,null,'');
        			PanelMapRoutes.setNewCenter(new google.maps.LatLng(record.get('geoY'),record.get('geoX')), 15);
        			setTimeout(function(){
        				PanelMapRoutes.deleteMarker('pointOnMap');
        			}, 9000);
        		} else {
        			Ext.Msg.alert(all_toir.error, routes_toir.you_can_not_see_the_point_of_uncount_route);
        		}
        		
        	}
        } 
    });
    
	if (!TOiR_routes_Window){
        Ext.getBody().mask(all.loading);
        TOiR_routes_Window = new Ext.Window({
            layout : 'border',
            //title : 'Мониторинг маршрутов',
			title : routes_toir.monitoring_routes,
            closeAction : 'destroy',
            width : parseInt(Wwidth),
            height : parseInt(Wheight),
            //minimizable: true,
			/*constrainHeader: true,
            maximizable:true,*/
            maximizable:true,
            constrainHeader: false,
			x : 2,
            y : 29,
            defaults: {
                //collapsible: true,
                //split: true,
                resizable: true,
            },
            //x : parseInt(Xcoord),
            //y : parseInt(Ycoord),
			listeners : {
            	destroy : function(){
            		TOiR_routes_Window = null;	
            	}
            },
            items : [{
	                //title: 'Результаты отчета',
	                layout: 'fit',
				    collapsible: false,
	                region:'center',
	                margins: '5 5 5 0',
	                items:[
	                       	PanelMapRoutes
					]
			    }, {
			    	layout: 'fit',
				    collapsible: false,
	                region:'west',
	                margins: '5 5 5 0',
	                width: '40%',
	                items:[
	                       	westPanel  	
					]			    	
			    }, {
			    	layout: 'fit',
				    collapsible: false,
	                region:'south',
	                margins: '5 5 5 0',
	                height: '40%',
	                items:[
	                       southPanel
					]	
			    }]
        });
	}      
	 TOiR_routes_Window.show(); 
	 Ext.getBody().unmask(all.loading);
		var time = Ext.getCmp('monitoring_date_id').getRawValue();		
		TOiR_TripPlanningStoreRoutes.load({
			params: {
				time: time
			}
		});
}	
var globalMarkerObj = {};
var globalRouteLine = {};
function tracingRoute (trip_id) {
	 $.post('app/TOiR_planning.php', {func: 'calculateTrip', id: trip_id}, function(data) {
		 
		 if (data != 0) {			 
			 var objData = Ext.decode(data);
			 var arrOfWaypoints = [];
			 var arrOfMarkers = [];
			 for (var key in objData) {
				 console.log(objData[key][0]);
				 GoogleLatLng = new google.maps.LatLng(objData[key][1],objData[key][0]);
				 var marker = PanelMapRoutes.addMarker(GoogleLatLng,{cursor:'outlet_'+objData[key][2], icon:'images/record.png'},false,false,null,'');
				 arrOfWaypoints.push({
			          location: GoogleLatLng,
			          stopover:true});
				 globalMarkerObj[trip_id] = arrOfMarkers;
				 arrOfMarkers.push(marker);
				 //[key] = marker;
			 }
			 
			 console.log(globalMarkerObj);
			 GoogleLatLng = new google.maps.LatLng(globalOfficeGeoY,globalOfficeGeoX);
			 PanelMapRoutes.addMarker(GoogleLatLng,{cursor:'outlet_main_' + trip_id, /*icon:'images/record.png'*/},false,false,null,'');
			 
			 $.post('app/TOiR_routes.php', {func: 'getRoutePath', trip_id: trip_id}, function(data){				 
				 
				 var path = eval("(" + data + ")");				 
				 var arrOfPoints = [];
				 for (var key in path) {					
					 point = {lat: parseFloat(path[key]['k']), lng: parseFloat(path[key]['B'])};
					 arrOfPoints.push(point);
				 }				 
				 globalRouteLine[trip_id] =  PanelMapRoutes.addPolyline(arrOfPoints,{strokeColor: '#538929',strokeOpacity: 1.0,strokeWeight: 5} );
				 
			 });
			
		 }
	 });
	 
}

function offTracingPoute(trip_id) {
	PanelMapRoutes.deleteMarker('outlet_main_' + trip_id);
	if (globalMarkerObj[trip_id]) {
		for (var key in globalMarkerObj[trip_id]) {
			globalMarkerObj[trip_id][key].setMap(null);
		}
	}
	if (globalRouteLine[trip_id]) {
		globalRouteLine[trip_id].setMap(null);		
	 }
}

function clearMapMonitoring() {
	
	PanelMapRoutes.deleteMarker('outlet_main_');
	for (var key in globalMarkerObj) {
		for (var key2 in globalMarkerObj[key]) {
			console.log(key + ' ' + key2);
			globalMarkerObj[key][key2].setMap(null);
		}
	}
	globalMarkerObj = {};
	for (var key in globalRouteLine) {		
		globalRouteLine[key].setMap(null);
		PanelMapRoutes.deleteMarker('outlet_main_' + key);		
	}	
	globalRouteLine = {};
}

function reloadGridByTime(globalUserIDRout, time) {
	pointsVisitStoreRoutes.load({
		params: {
			userID: globalUserIDRout,
			time: time
		}
	});
	console.log('monit');
}